



for i = 1 : 1   

    if i ==tp+1
        r_path = rh * ones(T,1);
    end
    
  %  suppose X has the following structure: X = (Z_t, Z_t+1_hat,...)
  %  it can be converted into a format that is required for input into
  %  objective by executing the following:
  %    X=X(:); 
  
    objective =@(X)ZLB_eqm_conditions_distortionary_tax(X,Zss,i,a_path,r_path,tau_path,t_g_path,G_path,sigma,psi,epsilon,theta,rhoR,phic,phipi,g,eta,omega1,omega2,util_type,lump,III);
    objective(Z_initial_guess);

    [Z_star,fval,exitflag]=fsolve(objective,Z_initial_guess,options);
    if exitflag ~= 1
        error('fatal (stochastic_simulation_distortionary_tax) fsolve did not solve the problem')
    end
    eee=objective(Z_star);
    max_err=max(max(abs(eee)));
    if max_err > .1e-12
        fprintf(' WARNING ( STOCHASTIC_SIMULATION_DISTORTIONARY_TAX) SOLUTION NOT ACCURATE\n')
        fprintf(' maximal error over all dates and variables = %9.7e\n',max_err)
        keyboard
    end
  
    Z_star = reshape(Z_star,N,T-i+1); % Z_star = (Z_t, Z_t+1_hat,...)
    % Store the forecast at time t
    Z_forecast{i,1} = Z_star; %#ok<*SAGROW>
    % Store the actual realization at time t
    Z_actual(:,i) = Z_star(:,1);
        
    % Use the forecast as the initial guess
    Z_initial_guess = Z_star(:,2:end);
    Z_initial_guess = Z_initial_guess(:);


    % Small check    
    if  max(abs(fval)) > 1e-10
        error('fatal failed to solve for baseline equilibrium')
    end
    
    if exitflag~=1
        disp('The solution might not be optimal even though it is close to 0...')
    end
    
    
end
