function [Z_initial_guess,Z_initial_without_guess] = get_started(init,xZss,xT,xlump,fname)
if init ~= 1
    Z_initial_guess        = repmat(xZss,xT,1);
    Z_initial_without_guess= repmat(xZss,xT,1);
else
    eval(['load ',fname]);
    n=size(Z_impulse,1);
    if n ~= 7 && n~= 10
        error('fatal (get_started) wrong dimension for Z_impulse on input')
    end
    if size(Z_impulse,2) ~= xT
        error('fatal(get_started) unexpected values for T and length of Z')
    end
    if xlump == 1
        Z_impulse=Z_impulse(1:7,:);
        Z_without_impulse=Z_without_impulse(1:7,:);
    end
    Z_initial_guess=Z_impulse(:);
    Z_initial_without_guess=Z_without_impulse(:);
end